<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: lib-settings.inc.php 3309 2005-06-09 11:30:28Z andrew $
*/

// Require the initialisation file
require_once '../../init.php';

// Required files
require_once MAX_PATH . '/lib/max/Admin/Config.php';
require_once MAX_PATH . '/lib/max/language/Default.php';
require_once MAX_PATH . '/lib/max/language/Settings.php';
require_once MAX_PATH . '/lib/max/language/SettingsHelp.php';
if ($conf['max']['installed']) {
	include_once MAX_PATH . '/www/admin/config.php';
}

// Load the required language files
Language_Default::load();
Language_Settings::load();
Language_SettingsHelp::load();

// Determine wether the config file is locked
$phpAds_config_locked = !MAX_Admin_Config::isConfigWritable();

/*-------------------------------------------------------*/
/* Build a menu with all settings                        */
/*-------------------------------------------------------*/

function phpAds_SettingsSelection($section)
{
	global $phpAds_TextDirection, $strHelp;
	global $tabindex;
	if(!isset($tabindex)) $tabindex = 1;

?>
<script language="JavaScript">
<!--
function settings_goto_section()
{
	s = document.settings_selection.section.selectedIndex;
	s = document.settings_selection.section.options[s].value;
	document.location = 'settings-' + s + '.php';
}
// -->
</script>
<?php
	echo "<table border='0' width='100%' cellpadding='0' cellspacing='0'>";
    echo "<tr><form name='settings_selection'><td height='35'><b>";
    echo $GLOBALS['strChooseSection'].":&nbsp;</b>"; 
	echo "<select name='section' onChange='settings_goto_section();' tabindex='".($tabindex++)."'>";
	if (phpAds_isUser(phpAds_Admin)) {
		echo "<option value='admin'".($section == 'admin' ? ' selected' : '').">".$GLOBALS['strAdministratorSettings']."</option>";
	}
	echo "<option value='banner'".($section == 'banner' ? ' selected' : '').">".$GLOBALS['strBannerSettings']."</option>";
	if (phpAds_isUser(phpAds_Admin)) {
		echo "<option value='db'".($section == 'db' ? ' selected' : '').">".$GLOBALS['strDatabaseSettings']."</option>";
		echo "<option value='debug'".($section == 'debug' ? ' selected' : '').">".$GLOBALS['strDebugSettings']."</option>";
		echo "<option value='delivery'".($section == 'delivery' ? ' selected' : '').">".$GLOBALS['strDeliverySettings']."</option>";
		echo "<option value='general'".($section == 'general' ? ' selected' : '').">".$GLOBALS['strGeneralSettings']."</option>";
		echo "<option value='geotargeting'".($section == 'geotargeting' ? ' selected' : '').">".$GLOBALS['strGeotargetingSettings']."</option>";
	}
	echo "<option value='defaults'".($section == 'defaults' ? ' selected' : '').">".$GLOBALS['strInterfaceDefaults']."</option>";
	echo "<option value='invocation'".($section == 'invocation' ? ' selected' : '').">".$GLOBALS['strInvocationAndDelivery']."</option>";
	if (phpAds_isUser(phpAds_Admin)) {
	   echo "<option value='stats'".($section == 'stats' ? ' selected' : '').">".$GLOBALS['strStatisticsSettings']."</option>";
	}	
	echo "<option value='interface'".($section == 'interface' ? ' selected' : '').">".$GLOBALS['strGuiSettings']."</option>";	
	echo "</select>&nbsp;<a href='javascript:void(0)' onClick='settings_goto_section();'>";
	echo "<img src='images/".$phpAds_TextDirection."/go_blue.gif' border='0'></a>";
    echo "</td></form>";
	echo "<td height='35' align='right'><b><a href=\"#\" onClick=\"javascript:toggleHelp(); return false;\">";
	echo "<img src='images/help-book.gif' width='15' height='15' border='0' align='absmiddle'>";
	echo "&nbsp;".$strHelp."</a></b></td></tr></table>";
	phpAds_ShowBreak();
}

/*-------------------------------------------------------*/
/* Return Settings Help HTML Code                        */
/*-------------------------------------------------------*/

function phpAds_SettingsHelp($name)
{
	if (!isset($GLOBALS['phpAds_hlp_'.$name])) {
		$GLOBALS['phpAds_hlp_'.$name] = '';
	}
	$string = $GLOBALS['phpAds_hlp_'.$name];
	$string = ereg_replace ("[\n\r\t]", " ", $string);
	$string = ereg_replace ("[ ]+", " ", $string);
	$string = str_replace("'", "\\'", $string);
	$string = trim ($string);
	return "helpArray['$name'] = '".$string."';\n";
}

/*-------------------------------------------------------*/
/* Build and display the settings user interface         */
/*-------------------------------------------------------*/

function phpAds_ShowSettings($data, $errors = array())
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $pref = $GLOBALS['_MAX']['PREF'];
	global $tabindex;
	// Initialize tabindex (if not already done)
	if (!isset($tabindex)) {
	    $tabindex = 1;
	}
	// Determine if config file is writable
	$configLocked = !MAX_Admin_Config::isConfigWritable();
	// Show header
	if ($conf['max']['installed']) {
		$image = $configLocked ? 'closed' : 'open';
		echo "<form name='settingsform' method='post' action='".$_SERVER['PHP_SELF']."' onSubmit='return phpAds_formCheck(this);'>\n";
		echo "<br /><div class='errormessage'><img class='errormessage' src='images/padlock-".$image.".gif' width='16' height='16' border='0' align='absmiddle'>\n";
		echo $configLocked ? $GLOBALS['strEditConfigNotPossible'] : $GLOBALS['strEditConfigPossible'];
		echo "</div>\n";
	}
	$dependbuffer = "function phpAds_refreshEnabled() {\n";
	$checkbuffer  = '';
	$helpbuffer   = '';
	$i = 0;
	while (list(,$section) = each ($data)) {
		if (!isset($section['visible']) || $section['visible']) {
			if (isset($errors[$i])) {
				phpAds_ShowSettings_StartSection($section['text'], $errors[$i]);
			} else {
				phpAds_ShowSettings_StartSection($section['text']);
			}
			while (list(,$item) = each ($section['items'])) {
				if (!isset($item['visible']) || $item['visible']) {
					$item['enabled'] = showSettingsLocked($item);
					if (!$item['enabled']) {
						$dependbuffer .= phpAds_ShowSettings_CheckDependancies($data, $item);
					}
					if (count($errors)) {
						// Page is the result of an error message, get values from the input
						if (isset($item['name']) && isset($GLOBALS[$item['name']])) {
							$value = $GLOBALS[$item['name']];
						} else {
							$value = '';
						}
					} else {
						// Get the values from the config file
    					$value = '';
						if (isset($item['name'])) {
                            // Split into config sections
						    list($configLevel, $configItem) = explode('_', $item['name']);
						    if (isset($conf[$configLevel][$configItem])) {
						        // Load the configuration .ini file value
    							$value = $conf[$configLevel][$configItem];
						    } elseif (isset($conf[$item['name']][0])) {
						        // Configuration .ini file item is stored as an array,
						        // re-constitute into a comma separated list
						        $value = implode(', ', $conf[$item['name']]);
						    } elseif (isset($pref[$item['name']])) {
						        // Load the preference value
						        $value = $pref[$item['name']];
						    }
						}
					}
					switch ($item['type']) {
						case 'break': 	  phpAds_ShowSettings_Break($item); break;
						case 'checkbox':  phpAds_ShowSettings_Checkbox($item, $value); break;
						case 'text':	  phpAds_ShowSettings_Text($item, $value); break;
						case 'url':	      phpAds_ShowSettings_Url($item, $value); break;
						case 'urln':      phpAds_ShowSettings_Url($item, $value, 'n'); break;
						case 'urls':      phpAds_ShowSettings_Url($item, $value, 's'); break;
						case 'textarea':  phpAds_ShowSettings_Textarea($item, $value); break;
						case 'password':  phpAds_ShowSettings_Password($item, $value); break;
						case 'select':    phpAds_ShowSettings_Select($item, $value); break;
					}
					if (isset($item['check']) || isset($item['req'])) {
						if (!isset($item['check'])) {
						    $item['check'] = '';
						}
						if (!isset($item['req'])) {
						    $item['req'] = false;
						}
						$checkbuffer .= "phpAds_formSetRequirements('".$item['name']."', '".addslashes($item['text'])."', ".($item['req'] ? 'true' : 'false').", '".$item['check']."');\n";
						if (isset($item['unique'])) {
							$checkbuffer .= "phpAds_formSetUnique('".$item['name']."', '|".addslashes(implode('|', $item['unique']))."|');\n";
						}
					}
					if (isset($item['name'])) {
						$helpbuffer .= phpAds_SettingsHelp($item['name']);
					}
				}
			}
			phpAds_ShowSettings_EndSection();
		}
		$i++;
	}
	if ($conf['max']['installed']) {
		echo '<br /><br /><input type="submit" value="'.$GLOBALS['strSaveChanges'].'"></form>';
	}
	echo "<script language='JavaScript'>\n<!--\n\n";
	echo $dependbuffer."}\n\nphpAds_refreshEnabled();\n\n";
	echo $checkbuffer."\n";
	echo "var helpArray = new Array();\n\n";
	echo $helpbuffer."\n";
	echo "//-->\n</script>";
}

/*-------------------------------------------------------*/
/* Settings GUI Functions Wrappers                       */
/*-------------------------------------------------------*/

function phpAds_ShowSettings_CheckDependancies($data, $item)
{
	if (isset($item['depends'])) {
		$depends    = split('[ ]+', $item['depends']);
		$javascript = "\tenabled = (";
		$result     = true;
		while (list(,$word) = each($depends)) {
			if (ereg('[\&\|]{1,2}', $word)) {
				// Operator
				$javascript .= " ".$word." ";
			} else {
				// Assignment
				eregi ("^(\(?)([a-z0-9_-]+)([\=\!\<\>]{1,2})([\"\'a-z0-9_-]+)(\)?)$", $word, $regs);
				$type 		 = phpAds_ShowSettings_GetType($data, $regs[2]);
				$javascript .= $regs[1]."document.settingsform.".$regs[2].".";
				switch ($type){
					case 'checkbox':	$javascript .= 'checked'; break;
					case 'select':		$javascript .= 'selectedIndex'; break;
					default:			$javascript .= 'value'; break;
				}
				$javascript .= " ".$regs[3]." ".$regs[4].$regs[5];
			}
		}
		$javascript .= ");\n";
		$javascript .= "\tdocument.settingsform.".$item['name'].".disabled = !enabled;\n";
		$javascript .= "\tobj = findObj('cell_".$item['name']."'); if (enabled) { obj.className = 'cellenabled'; } else { obj.className =  'celldisabled'; }\n";
		$javascript .= "\t\n";
		return ($javascript);
	}
	return ('');
}

function phpAds_ShowSettings_GetType ($data, $name)
{
	while (list(,$section) = each ($data)) {
		while (list(,$item) = each ($section['items'])) {
			if (isset($item['name']) && $item['name'] == $name) {
				return ($item['type']);
			}
		}
	}
	return false;
}

function phpAds_ShowSettings_StartSection($name, $error = array())
{
    $conf = $GLOBALS['_MAX']['CONF'];
	$icon = (!$conf['max']['installed']) ? 'setup' : 'settings';
	echo "\t<br /><br />\n\n";
	echo "<table border='0' width='100%' cellpadding='0' cellspacing='0'><tr>\n";
	echo "<input type='hidden' name='submit' value='true'>\n";
    echo "<td height='25' colspan='4'><img src='images/icon-".$icon.".gif' width='16' height='16' align='absmiddle'>&nbsp;";
	echo "<b>".$name."</b></td></tr>\n";
	echo "<tr height='1'>\n"; 
    echo "<td bgcolor='#888888' width='30'><img src='images/break.gif' height='1' width='30'></td>\n";
    echo "<td bgcolor='#888888' width='250'><img src='images/break.gif' height='1' width='250'></td>\n";
    echo "<td bgcolor='#888888' width='100%'><img src='images/break.gif' height='1' width='1'></td>\n";
    echo "<td bgcolor='#888888' width='30'><img src='images/break.gif' height='1' width='30'></td>\n";
	echo "</tr><tr><td height='10' colspan='4'><img src='images/spacer.gif' width='30' height='1'></td></tr>\n";
	if (count($error)) {
		echo "<tr><td width='30'>&nbsp;</td><td height='10' colspan='2'>";
		echo "<table width='100%' border='0' cellspacing='0' cellpadding='0'><tr>";
        echo "<td width='22' valign='top'><img src='images/error.gif' width='16' height='16'>&nbsp;&nbsp;</td>";
        echo "<td valign='top'><font color='#AA0000'><b>";
		while (list(, $v) = each($error)) {
			echo $v."<br />";
		}
		echo "</b></font></td></tr></table></td></tr>";
		echo "<tr><td height='10' width='30'>&nbsp;</td>";
		echo "<td height='10' width='200'><img src='images/spacer.gif' width='200' height='1'></td>";
		echo "<td height='10' width='100%'>&nbsp;</td><td height='10' width='30'>&nbsp;</td></tr>";
		echo "<tr><td height='14' width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
    	echo "<td height='14' width='200'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td>";
		echo "<td height='14' width='100%'>&nbsp;</td><td height='14' width='30'><img src='images/spacer.gif' height='1' width='100%'></tr>";
	}
}

function phpAds_ShowSettings_EndSection()
{
	echo "<tr><td height='10' colspan='4'>&nbsp;</td></tr>\n";
  	echo "<tr height='1'><td colspan='4' bgcolor='#888888'><img src='images/break.gif' height='1'></td></tr>\n";
	echo "</table>\n<br /><br />\n";
}

function phpAds_ShowSettings_Break($item)
{
	if (!isset($item['size']) || $item['size'] == '' || $item['size'] == 'small') {
	  	echo "<tr><td><img src='images/spacer.gif' height='1' width='100%'></td>\n";
	    echo "<td><img src='images/break-l.gif' height='1' width='250' vspace='10'></td>\n";
	    echo "<td>&nbsp;</td><td><img src='images/spacer.gif' height='1' width='100%'></tr>\n";
	} else if ($item['size'] == 'large') {
	  	echo "<tr><td><img src='images/spacer.gif' height='1' width='100%'></td>\n";
	    echo "<tdcolspan='3'><img src='images/break-l.gif' height='1' width='100%' vspace='10'></td></tr>\n";
	} else if ($item['size'] == 'full') {
		echo "<tr><td colspan='4'><img src='images/break.gif' height='1' width='100%' vspace='16'></td></tr>\n";
	} else if ($item['size'] == 'empty') {
		echo "<tr><td><img src='images/spacer.gif' height='1' width='100%'></td>\n";
	    echo "<td><img src='images/spacer.gif' height='1' width='250' vspace='10'></td>\n";
	    echo "<td>&nbsp;</td><td><img src='images/spacer.gif' height='1' width='100%'></tr>\n";
	}
}

function phpAds_ShowSettings_Checkbox($item, $value)
{
	global $tabindex;
	echo "<tr onMouseOver=\"setHelp('".$item['name']."')\"><td>&nbsp;</td>\n";
    echo "<td id='cell_".$item['name']."' class='".($item['enabled'] ? 'celldisabled' : 'cellenabled')."' colspan='2' width='100%'>\n";
	if (isset($item['indent']) && $item['indent']) {
		echo "<img src='images/indent.gif'>\n";
	}
	echo "<input type='checkbox' name='".$item['name']."' value='true'".($value == true ? ' checked' : '').($item['enabled'] ? ' disabled' : '');
	echo " onClick=\"phpAds_refreshEnabled();\" onFocus=\"setHelp('".$item['name']."')\" tabindex='".($tabindex++)."'>".$item['text'];
	echo "</td><td>".phpAds_ShowSettings_PadLock($item)."</td></tr>\n";
}

function phpAds_ShowSettings_Text($item, $value)
{
	global $tabindex;
	if (!isset($item['size'])) {
	    $item['size'] = 25;
	}
 	echo "<tr onMouseOver=\"setHelp('".$item['name']."')\"><td>&nbsp;</td>\n";
    echo "<td id='cell_".$item['name']."' class='".($item['enabled'] ? 'celldisabled' : 'cellenabled')."' valign='top'>".$item['text']."</td>\n";
    echo "<td width='100%' valign='top'>";
	echo "<input onBlur='phpAds_refreshEnabled(); phpAds_formUpdate(this);' class='flat' type='text' name='".$item['name']."'".($item['enabled'] ? ' disabled' : '')." ";
	echo "size='".$item['size']."' value=\"".htmlspecialchars($value)."\" onFocus=\"setHelp('".$item['name']."')\" tabindex='".($tabindex++)."'>";
	echo "</td><td>".phpAds_ShowSettings_PadLock($item)."</td></tr>\n";
}

function phpAds_ShowSettings_Url($item, $value, $type = '')
{
	global $tabindex;
	if (!isset($item['size'])) {
	    $item['size'] = 25;
	}
 	echo "<tr onMouseOver=\"setHelp('".$item['name']."')\"><td>&nbsp;</td>\n";
    echo "<td id='cell_".$item['name']."' class='".($item['enabled'] ? 'celldisabled' : 'cellenabled')."' valign='top'>".$item['text']."</td>\n";
    echo "<td width='100%' valign='top'><table><tr><td width='60' align='right' nowrap>";
    if ($type == 'n') {
        echo 'http://';
    } elseif ($type == 's') {
        echo 'https://';
    } else {
        echo 'http(s)://';
    }
	echo "</td><td><input onBlur='phpAds_refreshEnabled(); phpAds_formUpdate(this);' class='flat' type='text' name='".$item['name']."'".($item['enabled'] ? ' disabled' : '')." ";
	echo "size='".$item['size']."' value=\"".htmlspecialchars($value)."\" onFocus=\"setHelp('".$item['name']."')\" tabindex='".($tabindex++)."'>";
	echo "</td></tr></table></td><td>".phpAds_ShowSettings_PadLock($item)."</td></tr>\n";
}

function phpAds_ShowSettings_Textarea($item, $value)
{
	global $tabindex;
	if (!isset($item['rows'])) {
	    $item['rows'] = 5;
	}
 	echo "<tr onMouseOver=\"setHelp('".$item['name']."')\"><td>&nbsp;</td>\n";
    echo "<td id='cell_".$item['name']."' class='".($item['enabled'] ? 'celldisabled' : 'cellenabled')."' valign='top'>".$item['text']."</td>";
    echo "<td width='100%' valign='top'>\n";
	echo "<textarea onBlur='phpAds_refreshEnabled(); phpAds_formUpdate(this);' class='flat' name='".$item['name']."' rows='".$item['rows']."'".($item['enabled'] ? ' disabled' : '')." ";
	echo "style='width: 350px;' onFocus=\"setHelp('".$item['name']."')\" tabindex='".($tabindex++)."'>".htmlspecialchars($value)."</textarea>";
	echo "</td><td>".phpAds_ShowSettings_PadLock($item)."</td></tr>\n";
}

function phpAds_ShowSettings_Password($item, $value)
{
	global $tabindex;
	if (!isset($item['size'])) {
	    $item['size'] = 25;
	}
	// Hide value
	$value = str_repeat('*', strlen($value));
 	echo "<tr onMouseOver=\"setHelp('".$item['name']."')\"><td>&nbsp;</td>\n";
    echo "<td id='cell_".$item['name']."' class='".($item['enabled'] ? 'celldisabled' : 'cellenabled')."' valign='top'>".$item['text']."</td>\n";
    echo "<td width='100%' valign='top'>\n";
	echo "<input onBlur='phpAds_refreshEnabled(); phpAds_formUpdate(this);' class='flat' type='password' name='".$item['name']."'".($item['enabled'] ? ' disabled' : '')." ";
	echo "value='".$value."' size='".$item['size']."' onFocus=\"setHelp('".$item['name']."')\" tabindex='".($tabindex++)."'>";
	echo "</td><td>".phpAds_ShowSettings_PadLock($item)."</td></tr>\n";
}

function phpAds_ShowSettings_Select($item, $value)
{
	global $tabindex;
	if (isset($item['items'])) {
		echo "<tr onMouseOver=\"setHelp('".$item['name']."')\"><td>&nbsp;</td>\n";
    	echo "<td id='cell_".$item['name']."' class='".($item['enabled'] ? 'celldisabled' : 'cellenabled')."'>".$item['text']."</td>\n";
    	echo "<td width='100%'>\n";
		echo "<select name='".$item['name']."' onChange=\"phpAds_refreshEnabled();\"";
		echo ($item['enabled'] ? ' disabled' : '')." onFocus=\"setHelp('".$item['name']."')\" tabindex='".($tabindex++)."'>\n";
		while (list($k, $v) = each($item['items'])) {
			echo "<option value=\"".htmlspecialchars($k)."\"".
				($k == $value ? " selected" : "").">".
				$v."</option>";
		}
		echo "</select>";
		echo "</td><td>".phpAds_ShowSettings_PadLock($item)."</td></tr>\n";
	}
}

function phpAds_ShowSettings_PadLock($item)
{
	if (showSettingsLocked($item)) {
		return '<img src="images/padlock-closed.gif">';
	} else {
		return '&nbsp;';
	}
}

function showSettingsLocked($item)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if ($conf['max']['installed'] && isset($item['name'])) {
        // Split into config sections
	    list($configLevel, $configItem) = explode('_', $item['name']);
	    if (isset($conf[$configLevel][$configItem]) && (!MAX_Admin_Config::isConfigWritable())) {
			return true;
	    }
    }
    return false;
}

?>
